//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  CLR_NONE
#property indicator_color2  LimeGreen
#property indicator_color3  PaleVioletRed
#property indicator_color4  PaleVioletRed
#property indicator_width1  1
#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  2

//
//
//
//
//

extern int HalfLength1 = 25;
extern int HalfLength2 = 13;
extern int Mode = 2;
extern int Price = PRICE_CLOSE;
extern int NoOfBars = 300;

double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];
double slope[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//

int init()
{
   IndicatorDigits(6);
   IndicatorBuffers(5);
   SetIndexBuffer(0,buffer4);
   SetIndexBuffer(1,buffer1);
   SetIndexBuffer(2,buffer2);
   SetIndexBuffer(3,buffer3);
   SetIndexBuffer(4,slope);
   return(0);
}
int deinit() { return(0); }




//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double work[][10];
int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
        //   int limit=MathMin(Bars-counted_bars+MathMax(HalfLength1,HalfLength2)*5,Bars-1);
           
         //int limit=MathMin(Bars-counted_bars
           int limit=MathMin(NoOfBars-counted_bars+MathMax(HalfLength1,HalfLength2)*5,Bars-1);
         // limit = MathMin(NoOfBars-counted_bars,Bars-1);
         
           if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);

   //
   //
   //
   //
   //
   
   if (slope[limit]==-1) CleanPoint(limit,buffer2,buffer3);
   for (i=limit, r=Bars-i-1; i>=0; i--,r++)  work[r][0] = iMA(NULL,0,1,0,Mode,Price,i);
   for (i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      work[r][1] = iCSma(0,HalfLength1,i);
      work[r][2] = iCSma(0,HalfLength2,i);
      work[r][3] = 100.0*(work[r][1]-work[r][2]);
   }
   for (i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      work[r][4] = iCSma(3,HalfLength2,i);
      work[r][5] = 100.0*(work[r][4]-work[r-1][4]);
   }
   for (i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      work[r][6] = iCSma(5,HalfLength2,i);
      work[r][7] = 100.0*(work[r][6]-work[r-1][6]);
   }
   for (i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      work[r][8] = iCSma(7,HalfLength2,i);
      work[r][9] = work[r][8]-work[r-1][8];
         buffer1[i] = work[r][8];
         buffer2[i] = EMPTY_VALUE;
         buffer3[i] = EMPTY_VALUE;
         buffer4[i] = work[r][9];
         slope[i]   = slope[i+1];
            if (buffer1[i]>buffer1[i+1]) slope[i]= 1;
            if (buffer1[i]<buffer1[i+1]) slope[i]=-1;
            if (slope[i]==-1) PlotPoint(i,buffer2,buffer3,buffer1);
   }
   return(0);
}

//
//
//
//
//

double iCSma(int useValue, int halfLength, int i)
{
   i = Bars-i-1;
   
   //
   //
   //
   //
   //
      
   double sum  = work[i][useValue];
   double sumw = 1;
 
      //
      //
      //
      //
      //
      
      for(int j=1; j<=halfLength; j++)
      {
         sum  += work[i-j][useValue];
         sumw += 1;
            int k = MathMin(i+j,Bars-1);
            sum  += work[k][useValue];
            sumw += 1;
      }
   return(sum/sumw);      
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}